/****************************************************************************

Copyright (c) 2009 Intel Corporation.  All rights reserved. 



DISCLAIMER OF WARRANTY

NEITHER INTEL NOR ITS SUPPLIERS MAKE ANY REPRESENTATION OR WARRANTY OR

CONDITION OF ANY KIND WHETHER EXPRESS OR IMPLIED (EITHER IN FACT OR BY

OPERATION OF LAW) WITH RESPECT TO THE SOURCE CODE.  INTEL AND ITS SUPPLIERS

EXPRESSLY DISCLAIM ALL WARRANTIES OR CONDITIONS OF MERCHANTABILITY OR

FITNESS FOR A PARTICULAR PURPOSE.  INTEL AND ITS SUPPLIERS DO NOT WARRANT

THAT THE SOURCE CODE IS ERROR-FREE OR THAT OPERATION OF THE SOURCE CODE WILL

BE SECURE OR UNINTERRUPTED AND HEREBY DISCLAIM ANY AND ALL LIABILITY ON

ACCOUNT THEREOF.  THERE IS ALSO NO IMPLIED WARRANTY OF NON-INFRINGEMENT.

SOURCE CODE IS LICENSED TO LICENSEE ON AN "AS IS" BASIS AND NEITHER INTEL

NOR ITS SUPPLIERS WILL PROVIDE ANY SUPPORT, ASSISTANCE, INSTALLATION,

TRAINING OR OTHER SERVICES.  INTEL AND ITS SUPPLIERS WILL NOT PROVIDE ANY

UPDATES, ENHANCEMENTS OR EXTENSIONS. 


File Name:          CCommonDef.h

Description:

    This file defines class CCommonDef.

Environment (opt):
    OS: Ubuntu
    SE: Eclipse

Notes (opt):

  =====================================================================

  Revision   Revision History               Author     Date

  =====================================================================

  0.1        Create                         Jin Xin    2008/9/10

  =====================================================================

****************************************************************************/

#ifndef CCOMMONDEF_H_
#define CCOMMONDEF_H_

#include <string>
#include <vector>
#include <list>

namespace LibSESGUI
{

#define WEEKDAY 			(7)
#define HOURSADAY			(24)
#define GRID_WIDTH			(17)
#define GRID_HEIGHT			(18)
#define SEPERATOR_COUNT		(2)
#define HOUR_CAPTION_COUNT	(1)
#define	DAY_CAPTION_COUNT	(3)


#define PROGRAM_LIST_COLUMN_COUNT	(4)
#define CATEGORY_LIST_COLUMN_COUNT	(3)

const int ICON_WIDTH 	= 32;
const int ICON_HEIGHT	= 32;

const int LONG_BUTTON_WIDTH = 115;
const int LONG_BUTTON_HEIGHT = 35;
const int LLONG_BUTTON_WIDTH = 155;
const int SHORT_BUTTON_WIDTH = 55;
const int SSHORT_BUTTON_WIDTH = 32;
const int COMMON_BUTTON_WIDTH = 95;
const int COMMON_BUTTON_HEIGHT = 32;

const int COMMON_ENTRY_WIDTH = 220;
const int COMMON_ENTRY_HEIGHT = 26;
const int COMMON_ENTRY_MAX_LENGTH = 64;
const int COMMON_ENTRY_LIM_LENGTH = 20;

enum PROGRAMLIST
{
  COLUMN_ITEM_ENABLE = 0,
  COLUMN_ITEM_PIXBUF = 1,
  COLUMN_ITEM_PROGRAM_MAME = 2,
  COLUMN_ITEM_PROGRAM_POINTER = 3,
};

enum CATEGORYLIST
{
	COLUMN_ITEM_CATEGORY_ICON = 0,
	COLUMN_ITEM_CATEGORY_MAME = 1,
	COLUMN_ITEM_CATEGORY_POINTER = 2,
};

enum APP_SELECTION_LIST
{
	COLUMN_APPSEL_PIXMAP	= 0,
	COLUMN_APPSEL_NAME		= 1,
	COLUMN_APPSEL_POINTER	= 2,
	COLUMN_APPSEL_COUNT,
};

enum SES_GUI_RESULT
{
	SUCCESS = 0,
	FAILURE	= -1,
	INVALID_ARGS = -2,
};

enum SHELL_CONTROLLER_MODE
{
	FOR_SHELL_CONTROLLER = 0,
	FOR_ADMIN_TOOL = 1
};

//typedef struct Program
//{
//	bool bEnable;
//	std::string strAppName;
//	std::string strAppPath;
//	std::string strAppIcon;
//
//}Program;
//
//typedef struct Category
//{
//	std::string	strCategoryName;
//	std::vector<Program> vecPrograms;
//}Category;
//
//typedef std::list<Category> CategroyList;

}

#endif /* CCOMMONDEF_H_ */
