/****************************************************************************

Copyright (c) 2009 Intel Corporation.  All rights reserved. 



DISCLAIMER OF WARRANTY

NEITHER INTEL NOR ITS SUPPLIERS MAKE ANY REPRESENTATION OR WARRANTY OR

CONDITION OF ANY KIND WHETHER EXPRESS OR IMPLIED (EITHER IN FACT OR BY

OPERATION OF LAW) WITH RESPECT TO THE SOURCE CODE.  INTEL AND ITS SUPPLIERS

EXPRESSLY DISCLAIM ALL WARRANTIES OR CONDITIONS OF MERCHANTABILITY OR

FITNESS FOR A PARTICULAR PURPOSE.  INTEL AND ITS SUPPLIERS DO NOT WARRANT

THAT THE SOURCE CODE IS ERROR-FREE OR THAT OPERATION OF THE SOURCE CODE WILL

BE SECURE OR UNINTERRUPTED AND HEREBY DISCLAIM ANY AND ALL LIABILITY ON

ACCOUNT THEREOF.  THERE IS ALSO NO IMPLIED WARRANTY OF NON-INFRINGEMENT.

SOURCE CODE IS LICENSED TO LICENSEE ON AN "AS IS" BASIS AND NEITHER INTEL

NOR ITS SUPPLIERS WILL PROVIDE ANY SUPPORT, ASSISTANCE, INSTALLATION,

TRAINING OR OTHER SERVICES.  INTEL AND ITS SUPPLIERS WILL NOT PROVIDE ANY

UPDATES, ENHANCEMENTS OR EXTENSIONS. 


File Name:          CSearchProgramForAdminTool.h

Description:

    This file defines class CSearchProgramForAdminTool.

Environment (opt):
    OS: Ubuntu
    SE: Eclipse

Notes (opt):

  =====================================================================

  Revision   Revision History               Author     Date

  =====================================================================

  0.1        Create                         Jin Xin  2008/9/10

  =====================================================================

****************************************************************************/

#ifndef CSEARCHPROGRAMFORADMINTOOL_H_
#define CSEARCHPROGRAMFORADMINTOOL_H_

#include "CSearchProgramBase.h"
#include "CStudentAPICallbackBase.h"
#include "libsesdata.h"

namespace LibSESGUI
{

class CSearchProgramForAdminTool : public CSearchProgramBase, public IPCAPI::CStudentAPICallbackBase
{
public:
	CSearchProgramForAdminTool(int iSearchMode = 0);
	virtual ~CSearchProgramForAdminTool();

public:
	// GTK Handler
	static void GtkBrowseBtnClicked(GtkWidget *widget, gpointer data);

public:
	virtual int Init();
	virtual int OnSearchBtnClicked();
	virtual int CancelSearch();


public:
	virtual void SearchLocalProgramCallBack(std::string programsXML);

private:

	int OnBrowseBtnClicked();

private:
	//LibSESData::CSearchResultData	m_SearchResult;
	GtkWidget* m_gBrowseBtn;
};

}

#endif /* CSEARCHPROGRAMFORADMINTOOL_H_ */
