/****************************************************************************

Copyright (c) 2009 Intel Corporation.  All rights reserved. 



DISCLAIMER OF WARRANTY

NEITHER INTEL NOR ITS SUPPLIERS MAKE ANY REPRESENTATION OR WARRANTY OR

CONDITION OF ANY KIND WHETHER EXPRESS OR IMPLIED (EITHER IN FACT OR BY

OPERATION OF LAW) WITH RESPECT TO THE SOURCE CODE.  INTEL AND ITS SUPPLIERS

EXPRESSLY DISCLAIM ALL WARRANTIES OR CONDITIONS OF MERCHANTABILITY OR

FITNESS FOR A PARTICULAR PURPOSE.  INTEL AND ITS SUPPLIERS DO NOT WARRANT

THAT THE SOURCE CODE IS ERROR-FREE OR THAT OPERATION OF THE SOURCE CODE WILL

BE SECURE OR UNINTERRUPTED AND HEREBY DISCLAIM ANY AND ALL LIABILITY ON

ACCOUNT THEREOF.  THERE IS ALSO NO IMPLIED WARRANTY OF NON-INFRINGEMENT.

SOURCE CODE IS LICENSED TO LICENSEE ON AN "AS IS" BASIS AND NEITHER INTEL

NOR ITS SUPPLIERS WILL PROVIDE ANY SUPPORT, ASSISTANCE, INSTALLATION,

TRAINING OR OTHER SERVICES.  INTEL AND ITS SUPPLIERS WILL NOT PROVIDE ANY

UPDATES, ENHANCEMENTS OR EXTENSIONS. 


File Name:          CSearchProgramForShellController.h

Description:

    This file defines class CSearchProgramForShellController.

Environment (opt):
    OS: Ubuntu
    SE: Eclipse

Notes (opt):

  =====================================================================

  Revision   Revision History               Author     Date

  =====================================================================

  0.1        Create                         Jin Xin   2008/9/10

  =====================================================================

****************************************************************************/

#ifndef CSEARCHPROGRAMFORSHELLCONTROLLER_H_
#define CSEARCHPROGRAMFORSHELLCONTROLLER_H_

#include "CSearchProgramBase.h"
#include "CTeacherAPICallbackBase.h"

#include <set>

namespace LibSESGUI
{

class CSearchProgramForShellController : public CSearchProgramBase, public IPCAPI::CTeacherAPICallbackBase
{
public:
	CSearchProgramForShellController(int iSearchMode = 0);
	virtual ~CSearchProgramForShellController();

public:
	virtual int Init();
	virtual int OnSearchBtnClicked();
	virtual int CancelSearch();

public:
	virtual void SearchProgramCallBack(std::string studentID, std::string programsXML);

private:
	int m_iStudentIdx;
	int m_iStudentCount;

	//std::set<string> m_studentIdSet;
	//std::set<string> m_appNameSet;
};

}

#endif /* CSEARCHPROGRAMFORSHELLCONTROLLER_H_ */
